
%global pkg_name darcs
%global pkgver %{pkg_name}-%{version}

%global dataordlist data-ordlist-0.4.7.0
%global subpkgs %{dataordlist}


Name:           %{pkg_name}
Version:        2.16.5
Release:    1%{?dist}
Summary:        A distributed, interactive, smart revision control system

License:        GPL-2.0-or-later
Url:            https://hackage.haskell.org/package/%{name}
Source0:        https://hackage.haskell.org/package/%{pkgver}/%{pkgver}.tar.gz
Source1:        https://hackage.haskell.org/package/%{dataordlist}/%{dataordlist}.tar.gz

BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros-extra
BuildRequires:  ghc-array-devel
BuildRequires:  ghc-async-devel
BuildRequires:  ghc-attoparsec-devel
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-base16-bytestring-devel
BuildRequires:  ghc-binary-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-conduit-devel
BuildRequires:  ghc-constraints-devel
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-cryptonite-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-fgl-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-hashable-devel
BuildRequires:  ghc-haskeline-devel
BuildRequires:  ghc-html-devel
BuildRequires:  ghc-http-conduit-devel
BuildRequires:  ghc-http-types-devel
BuildRequires:  ghc-memory-devel
BuildRequires:  ghc-mmap-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-network-devel
BuildRequires:  ghc-network-uri-devel
BuildRequires:  ghc-old-time-devel
BuildRequires:  ghc-parsec-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-regex-applicative-devel
BuildRequires:  ghc-regex-base-devel
BuildRequires:  ghc-regex-tdfa-devel
BuildRequires:  ghc-stm-devel
BuildRequires:  ghc-tar-devel
BuildRequires:  ghc-temporary-devel
BuildRequires:  ghc-terminfo-devel
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-unix-devel
BuildRequires:  ghc-unix-compat-devel
BuildRequires:  ghc-utf8-string-devel
BuildRequires:  ghc-vector-devel
BuildRequires:  ghc-zip-archive-devel
BuildRequires:  ghc-zlib-devel
%if %{with ghc_prof}
BuildRequires:  ghc-array-prof
BuildRequires:  ghc-async-prof
BuildRequires:  ghc-attoparsec-prof
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-base16-bytestring-prof
BuildRequires:  ghc-binary-prof
BuildRequires:  ghc-bytestring-prof
BuildRequires:  ghc-conduit-prof
BuildRequires:  ghc-constraints-prof
BuildRequires:  ghc-containers-prof
BuildRequires:  ghc-cryptonite-prof
BuildRequires:  ghc-directory-prof
BuildRequires:  ghc-fgl-prof
BuildRequires:  ghc-filepath-prof
BuildRequires:  ghc-hashable-prof
BuildRequires:  ghc-haskeline-prof
BuildRequires:  ghc-html-prof
BuildRequires:  ghc-http-conduit-prof
BuildRequires:  ghc-http-types-prof
BuildRequires:  ghc-memory-prof
BuildRequires:  ghc-mmap-prof
BuildRequires:  ghc-mtl-prof
BuildRequires:  ghc-network-prof
BuildRequires:  ghc-network-uri-prof
BuildRequires:  ghc-old-time-prof
BuildRequires:  ghc-parsec-prof
BuildRequires:  ghc-process-prof
BuildRequires:  ghc-regex-applicative-prof
BuildRequires:  ghc-regex-base-prof
BuildRequires:  ghc-regex-tdfa-prof
BuildRequires:  ghc-stm-prof
BuildRequires:  ghc-tar-prof
BuildRequires:  ghc-temporary-prof
BuildRequires:  ghc-terminfo-prof
BuildRequires:  ghc-text-prof
BuildRequires:  ghc-time-prof
BuildRequires:  ghc-transformers-prof
BuildRequires:  ghc-unix-prof
BuildRequires:  ghc-unix-compat-prof
BuildRequires:  ghc-utf8-string-prof
BuildRequires:  ghc-vector-prof
BuildRequires:  ghc-zip-archive-prof
BuildRequires:  ghc-zlib-prof
%endif

BuildRequires:  bash-completion

%description
Darcs is a distributed, interactive, smart revision control system.
Darcs is easy to learn and efficient to use because it asks you questions
in response to simple commands, giving you choices in your workflow.
You can choose to record one change in a file, while ignoring another.
You can review each patch as you update from upstream.
Originally developed by physicist David Roundy,
darcs is based on a unique algebra of patches.


%package -n ghc-%{name}
Summary:        Haskell %{name} library

%description -n ghc-%{name}
This package provides the Haskell %{name} shared library.


%package -n ghc-%{name}-devel
Summary:        Haskell %{name} library development files
Provides:       ghc-%{name}-static = %{version}-%{release}
Provides:       ghc-%{name}-static = %{version}-%{release}
%if %{defined ghc_version}
Requires:       ghc-compiler = %{ghc_version}
%endif
Requires:       ghc-%{name} = %{version}-%{release}

%description -n ghc-%{name}-devel
This package provides the Haskell %{name} library development files.


%if %{with haddock}
%package -n ghc-%{name}-doc
Summary:        Haskell %{name} library documentation
BuildArch:      noarch
Requires:       ghc-filesystem

%description -n ghc-%{name}-doc
This package provides the Haskell %{name} library documentation.
%endif


%if %{with ghc_prof}
%package -n ghc-%{name}-prof
Summary:        Haskell %{name} profiling library
Requires:       ghc-%{name}-devel = %{version}-%{release}
Supplements:    (ghc-%{name}-devel and ghc-prof)

%description -n ghc-%{name}-prof
This package provides the Haskell %{name} profiling library.
%endif


%global main_version %{version}

%if %{defined ghclibdir}
%ghc_lib_subpackage %{dataordlist}
%endif

%global version %{main_version}


%prep
%setup -q -a1
%ifnarch %{ix86} x86_64 ppc
cabal-tweak-flag threaded False
%endif
cabal-tweak-dep-ver attoparsec '< 0.14' '< 0.15'
cabal-tweak-dep-ver base '< 4.16' '< 4.18'
cabal-tweak-dep-ver bytestring '< 0.11' '< 0.12'
cabal-tweak-dep-ver constraints '< 0.13' '< 0.14'
cabal-tweak-dep-ver cryptonite '< 0.30' '< 0.31'
cabal-tweak-dep-ver fgl '< 5.8' '< 5.9'
cabal-tweak-dep-ver hashable '< 1.4' '< 1.5'
cabal-tweak-dep-ver memory '< 0.17' '< 0.19'
cabal-tweak-dep-ver regex-tdfa '< 1.3.2' '< 1.4'
cabal-tweak-dep-ver text '< 1.3' '< 2.2'
cabal-tweak-dep-ver time '< 1.10' '< 1.13'
cabal-tweak-dep-ver unix-compat '< 0.6' '< 0.8'
cabal-tweak-dep-ver vector '< 0.13' '< 0.14'


%build
%ghc_libs_build %{subpkgs}
%ghc_lib_build


%install
%ghc_libs_install %{subpkgs}
%ghc_lib_install

install -Dpm 644 contrib/darcs_completion %{buildroot}%{_datadir}/bash-completion/completions/darcs


%files
%license COPYING
%doc CHANGELOG README.md
%{_bindir}/%{name}
%doc contrib/_darcs.zsh
%{_datadir}/bash-completion/
%attr(0644,-,-) %{_mandir}/man1/darcs.1*


%files -n ghc-%{name} -f ghc-%{name}.files
%license COPYING


%files -n ghc-%{name}-devel -f ghc-%{name}-devel.files
%doc CHANGELOG README.md


%if %{with haddock}
%files -n ghc-%{name}-doc -f ghc-%{name}-doc.files
%license COPYING
%endif


%if %{with ghc_prof}
%files -n ghc-%{name}-prof -f ghc-%{name}-prof.files
%endif


%changelog
* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.16.5-1
- initial build
